#|
Arxiu: util.lisp.
Contingut: utilitats d'interés general.
Autor: Felip Alàz Nadal.
�tima actualització 3-VI-06

|#


#|

BSD License

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

   1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
   2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


				
|#

;;Fitxer amb funcions tils
(provide :util)
(defpackage :util 
  (:use "CL")
  (:nicknames "UTIL")
  (:export #:repeat #:ht-keys #:ht-values)
  )
(in-package :util)

(defun repeat (que quant)
"Return the list obtained repeating que quant times."
  (let ((llista nil))
    (do ((contador 0 (+ contador 1)))
	((= contador quant) llista)
	(push que llista)
	)
    )
  )
;;Ací falten mèodes que generen llistes, tipus range


(defun ht-keys (hash )
  "Return a list with all the keys of a hash table."
  (let ((aux nil))
    (maphash #'(lambda (clau valor)
		 (declare (ignore valor))
		 (push clau aux)) hash)
    (reverse aux)))

(defun ht-values (hash )
  "Returns a list with all the values of a hash table."
  (let ((aux nil))
    (maphash #'(lambda (clau valor)
		 (declare (ignore clau))
		 (push valor aux)) hash)
    (reverse aux)))